#define EQU .equ
#define DB .byte
#define DW .word
#define DS .block
#define ORG .org



;#define exaf	push hl\ ld hl,(a_stor)\ push af\ ex (sp),hl\ pop af\ ld (a_stor),hl\ pop hl
;
;MOD 7 NOW SAVES HL' ON STACK AND RESTORES ON EXIT
;this speeds up replacement code for ex af,af'
;
;and save 12 bytes ;-)

#DEFINE exaf EXX\ PUSH AF\ EX (SP),HL\ POP AF\ EXX


;now the next real tricky bit, there are some sections of code that
;manipulate the SP in order to access values from tables
;i intend to modify the code so as to NOT use the sp
;in this way.


;VORTEX TRACKER II V1.0 PT3 PLAYER FOR ZX SPECTRUM
;(C)2004,2007 S.V.BULBA <VOROBEY@MAIL.KHSTU.RU>
;HTTP://BULBA.UNTERGRUND.NET (HTTP://BULBA.AT.KZ)

;MODIFIED FOR ZX81 BY Andrew Rea
;SOME changes for TASM assembler too.
;
;I undo some optimizesation because its
;not compatible with ZX81 display routines

;RELEASE NUMBER
RELEASE EQU $37		;ASCII CODE FOR '7'

;FEATURES
;--------
;-CAN BE COMPILED AT ANY ADDRESS (I.E. NO NEED ROUNDING ORG
; ADDRESS).
;-VARIABLES (VARS) CAN BE LOCATED AT ANY ADDRESS (NOT ONLY AFTER
;CODE BLOCK).
;-INIT SUBROUTINE DETECTS MODULE VERSION AND RIGHTLY GENERATES
; BOTH NOTE AND VOLUME TABLES OUTSIDE OF CODE BLOCK (IN VARS).
;-TWO PORTAMENTO (SPC. COMMAND 3XXX) ALGORITHMS (DEPENDING OF
; MODULE VERSION).
;-NEW 1.XX AND 2.XX SPECIAL COMMAND BEHAVIOUR (ONLY FOR PT V3.7
; AND HIGHER).
;-ANY TEMPO VALUE ARE ACCEPTED (INCLUDING TEMPO=1 AND TEMPO=2).
;-FULLY COMPATIBLE WITH AY_EMUL PT3 PLAYER CODES.
;-SEE ALSO NOTES AT THE END OF THIS SOURCE CODE.

;LIMITATIONS
;-----------
;-CAN RUN IN RAM ONLY (SELF-MODIFIED CODE IS USED).

;WARNING!!! PLAY SUBROUTINE CAN CRASH IF NO MODULE ARE LOADED
;INTO RAM OR INIT SUBROUTINE WAS NOT CALLED BEFORE.

;CALL MUTE OR INIT ONE MORE TIME TO MUTE SOUND AFTER STOPPING
;PLAYING 

;	ORG 8192

;TEST CODES (COMMENTED)
;	CALL START
;	EI
;_LP	HALT
;	CALL START+5
;	XOR A
;	IN A,($FE)
;	CPL
;	AND 15
;	JR Z,_LP
;	JR START+8

TONA	EQU 0
TONB	EQU 2
TONC	EQU 4
NOISE	EQU 6
MIXER	EQU 7
AMPLA	EQU 8
AMPLB	EQU 9
AMPLC	EQU 10
ENV	EQU 11
ENVTP	EQU 13

;CHANNELSVARS
;	STRUCT	CHP
;RESET GROUP
PSINOR	EQU 0
PSINSM	EQU 1
CRAMSL	EQU 2
CRNSSL	EQU 3
CRENSL	EQU 4
TSLCNT	EQU 5
CRTNSL	EQU 6
TNACC	EQU 8
CONOFF	EQU 10
;RESET GROUP

ONOFFD	EQU 11

;IY FOR PTDECOD HERE (+12)
OFFOND	EQU 12
ORNPTR	EQU 13
SAMPTR	EQU 15
NNTSKP	EQU 17
NOTE	EQU 18
SLTONT	EQU 19
ENV_EN	EQU 20
FLAGS	EQU 21
 ;ENABLED - 0,SIMPLEGLISS - 2
TNSLDL	EQU 22
TSLSTP	EQU 23
TNDELT	EQU 25
NTSKCN	EQU 27
VOLUME	EQU 28
;	ENDS
CHP	EQU 29

;ENTRY AND OTHER POINTS
;START INITIALIZATION
;START+3 INITIALIZATION WITH MODULE ADDRESS IN HL
;START+5 PLAY ONE QUARK
;START+8 MUTE
;START+10 SETUP AND STATUS FLAGS
;START+11 POINTER TO CURRENT POSITION VALUE IN PT3 MODULE;
;AFTER INIT (START+11) POINTS TO POSTION0-1 (OPTIMIZATION)


;do not call directly, code uses IY register and need to be called via the interrupt
;handler. ZX81 will mosy likely crash otherwise.
PLAYER_START:
PLAYER_PT3_ADDRESS .EQU (PLAYER_START +1)
;	LD HL,$8000
PLAYER_INIT:
	JR INIT
PLAYER_PLAY:
	JP PLAY
PLAYER_MUTE:
	JR MUTE
PLAYER_SETUP:
;SETUP	DB 0 ;SET BIT0 TO 1, IF YOU WANT TO PLAY WITHOUT LOOPING
	     ;BIT7 IS SET EACH TIME, WHEN LOOP POINT IS PASSED
CRPSPTR	DW 0 

;IDENTIFIER
	DB "=VTII PT3 PLAYER R.",RELEASE,"="

CHECKLP	
	LD HL,SETUP			;this is called when the player has reached
	SET 7,(HL)			;the loop point, set bit 7 to show player has reached
	BIT 0,(HL)			;loop point, test bit 0, is looping allowed ?
	RET Z				;bit 0 = 0 = looping allowed
	POP HL				;drop the return address ? (apr)
	LD HL,DELYCNT			;increment delycnt	
	INC (HL)				;before muting
	LD HL,CHANA+NTSKCN		
	INC (HL)
MUTE	
;moved the bodge to the interupt handler.

; 	EXX					;this is a bit of a bodge
; 	PUSH	HL				;by Andy Rea
; 	EXX					;save the HL'
; 	CALL MUTE_2_MOD7		
; 	EXX					;and when player is done
; 	POP	HL				;restore it
; 	EXX					;hl' is used as a temp store for af'
; 	RET
	
;MUTE_2_MOD7:

	XOR A				;zero a
	LD H,A				;hl = 0
	LD L,A		
	LD (AYREGS+AMPLA),A		;channel a, amplitude = 0 
	LD (AYREGS+AMPLB),HL	;channel b & c, amplitude = 0
						;setting all three amplitude registers to 
						;zero will mute the sound
						;bits 3-0 = amplitude (vol)
						;bit 4 = used envelope (when set) 
	JP ROUT_A0			;jump to the ay-register out routine

INIT
;moved the bodge to the interupt handler.

; 	EXX					;as above.
; 	PUSH	HL
; 	EXX
; 	CALL INIT_2_MOD7
; 	EXX
; 	POP	HL
; 	EXX
; 	RET
; 	
; INIT_2_MOD7:
;HL - ADDRESSOFMODULE module has 100 byte header.

	LD (MODADDR),HL		;save the module addres
	LD (MDADDR2),HL		;twice
	PUSH HL				;and on stack
	LD DE,100				;prepare top add 100
	ADD HL,DE				;skip over header
	LD A,(HL)				;first byte is speed (delay)
	LD (DELAY),A			;save it
	PUSH HL				;copy value
	POP IY				;to IY
	ADD HL,DE				;add another 100 to module address points at start +100 
	LD (CRPSPTR),HL		;save it in current position pointer, can be read by
						;user code to see where in music you are
	LD E,(IY+102-100)		;load de with new value (d=0 already)
						;this is the loop position
	ADD HL,DE				;add to hl
	INC HL				;+1
	LD (LPOSPTR),HL		;save the loop pointer
	POP DE				;remeber the original module address on the stack.
	LD L,(IY+103-100)		;get the patterns offset from
	LD H,(IY+104-100)		;the module
	ADD HL,DE				;add the original address
	LD (PATSPTR),HL		;this is the pointer to patterns
	LD HL,169				;offset into file
	ADD HL,DE				
	LD (ORNPTRS),HL		;ornaments pointer
	LD HL,105
	ADD HL,DE
	LD (SAMPTRS),HL		;samples pointer
	LD HL,SETUP			;reset bit 7
	RES 7,(HL)			;of the loop indicator 



	LD DE,T_PACK			;load de with the address of the packed notes
	LD BC,T1_+(2*49)-1		;load bc with the adress to unpack notes
TP_0	LD A,(DE)				;get a byte from the packed notes
	INC DE				;point de to next entry
	CP 15*2				;compare byte fetched with 30, why 30 ?
	JR NC,TP_1			;jump if value was > 30
	LD H,A				;else load h with a
	LD A,(DE)				;get the next byte
	LD L,A				;load l with a
	INC DE				;point to next byte
	JR TP_2				;skip next section
	
TP_1	PUSH DE				;save pointer on stack
	LD D,0				;d = 0
	LD E,A				;value fetched into e
	ADD HL,DE				;add twice to hl, but what was hl ?
	ADD HL,DE				;looks like HL was previous note value.
	POP DE				;get de back
	
TP_2	LD A,H				;put half note value into a
	LD (BC),A				;store it
	DEC BC				;decrement store pointer
	LD A,L				;other half of note value
	LD (BC),A				;store it
	DEC BC				;decrement store pointer again
	SUB $F8*2				;sub $f0 (240) from a
	JR NZ,TP_0			;if not equal go back for more notes

	LD HL,VARS			;start of variables area
	LD (HL),A				;a will be zero
	LD DE,VARS+1			;start +1
	LD BC,VAR0END-VARS-1	;length -1
	LDIR					;fill with 0's
	
	INC A				;a = 1
	LD (DELYCNT),A			;initial delay count
	
	LD HL,$F001 ;H - VOLUME, L - NTSKCN
	LD (CHANA+NTSKCN),HL	;initial values for channels
	LD (CHANB+NTSKCN),HL
	LD (CHANC+NTSKCN),HL

	LD HL,EMPTYSAMORN
	LD (ADINPTA),HL 		;PTR TO ZERO
	LD (CHANA+ORNPTR),HL 	;ORNAMENT 0 IS "0,1,0"
	LD (CHANB+ORNPTR),HL 	;IN ALL VERSIONS FROM
	LD (CHANC+ORNPTR),HL 	;3.XX TO 3.6X AND VTII

	LD (CHANA+SAMPTR),HL	;S1 THERE IS NO DEFAULT
	LD (CHANB+SAMPTR),HL 	;S2 SAMPLE IN PT3, SO, YOU
	LD (CHANC+SAMPTR),HL 	;S3 CAN COMMENT S1,2,3; SEE
				    		;ALSO EMPTYSAMORN COMMENT

	LD A,(IY+13-100) 	;EXTRACT VERSION NUMBER
	SUB $30
	JR C,L20
	CP 10
	JR C,L21
L20	LD A,6
L21	LD (VERSION),A
	PUSH AF			;af on stack 
	CP 4
	LD A,(IY+99-100) 	;TONE TABLE NUMBER
	RLA				;mult x2
	AND 7			;keep only 3 bits
					;(0=table 0, 2=table 1, 4=table 2, 6=table 3)
					

;NOTETABLECREATOR (C) IVAN ROSHIN
;A - NOTETABLENUMBER*2+VERSIONFORNOTETABLE
;(XX1B - 3.XX..3.4R, XX0B - 3.4X..3.6X..VTII1.0)

	LD HL,NT_DATA
	PUSH DE			;de on stack, end of notetable we just created
	LD D,B			;zero d, i think BC is zero from the LDIR above
	ADD A,A			;double a again, so we now have 4*notetable version
	LD E,A			;and stick it in e, de = 4 * notetable
	ADD HL,DE			;add to NT_data
	LD E,(HL)			;get a byte from nt_data
	INC HL			;hl points to next entry
	SRL E			;div 2 bit 0 into carry
	SBC A,A			;if carry set a=$ff else a=0
					;and now the following instruction makes sense ;-)
	AND $A7 			;$00 (NOP) OR $A7 (AND A)
	LD (L3),A			;modify code below
	EX DE,HL			;de now pointer to nt_data
	POP BC 			;BC=T1_	;pop de from above	
	ADD HL,BC			;and add notetabel version

	;this is a cool way to add
	;a word (T_) to a byte (a)
	;the assembler chucks a wobbler
	;saying there is unused data
	
	LD A,(DE)			;get the byte
	ADD A,T_			;add it to t_ (this is adding low byte)
					;as assembler ignores high byte
	LD C,A			;put in c
	ADC A,T_/256		;add high byte + any carry
	SUB C			;minus original low byte 
	LD B,A			;leaves just the high byte 
	PUSH BC			;save word result
	LD DE,NT_
	PUSH DE
					;and then i got confused....
					;maybe i'll come back to this sectio
					;
					
	LD B,12
L1	PUSH BC
	LD C,(HL)
	INC HL
	PUSH HL
	LD B,(HL)

	PUSH DE
	EX DE,HL
	LD DE,23
	LD IYH,8

L2	SRL B
	RR C
L3	DB $19	;AND A OR NOP
	LD A,C
	ADC A,D	;=ADC 0
	LD (HL),A
	INC HL
	LD A,B
	ADC A,D
	LD (HL),A
	ADD HL,DE
	DEC IYH
	JR NZ,L2

	POP DE
	INC DE
	INC DE
	POP HL
	INC HL
	POP BC
	DJNZ L1

	POP HL
	POP DE

	LD A,E
	CP TCOLD_1
	JR NZ,CORR_1
	LD A,$FD
	LD (NT_+$2E),A

CORR_1	LD A,(DE)
	AND A
	JR Z,TC_EXIT
	RRA
	PUSH AF
	ADD A,A
	LD C,A
	ADD HL,BC
	POP AF
	JR NC,CORR_2
	DEC (HL)
	DEC (HL)
CORR_2	INC (HL)
	AND A
	SBC HL,BC
	INC DE
	JR CORR_1

TC_EXIT

	POP AF			;af back from way up there ^^^^

;VOLTABLECREATOR (C) IVAN ROSHIN
;A - VERSIONFORVOLUMETABLE (0..4 - 3.XX..3.4X;
			   ;5.. - 3.5X..3.6X..VTII1.0)

	CP 5
	LD HL,$11			;h = 0, l = $11
	LD D,H			;d = 0
	LD E,H			;e = 0
	LD A,$17
	JR NC,M1			;or some other value ...
	DEC L
	LD E,L
	XOR A			;a = 0
M1      LD (M2),A		;modifies byte below which is initially set to ld a,l
					

	LD IY,VT_+16
	LD C,$10

INITV2  PUSH HL

	ADD HL,DE
	EX DE,HL
	SBC HL,HL

INITV1  LD A,L
M2      DB $7D		;LD A,L or RLA  or NOP
	LD A,H
	ADC A,0
	LD (IY),A
	INC IY
	ADD HL,DE
	INC C
	LD A,C
	AND 15
	JR NZ,INITV1

	POP HL
	LD A,E
	CP $77
	JR NZ,M3
	INC E
M3      LD A,C
	AND A
	JR NZ,INITV2

	JP ROUT_A0

;PATTERN DECODER
PD_ORSM	LD (IY-12+ENV_EN),0
	CALL SETORN
	LD A,(BC)
	INC BC
	RRCA

PD_SAM	ADD A,A
PD_SAM_	LD E,A
	LD D,0
SAMPTRS EQU $+1
	LD HL,$2121
	ADD HL,DE
	LD E,(HL)
	INC HL
	LD D,(HL)
MODADDR EQU $+1
	LD HL,$2121
	ADD HL,DE
	LD (IY-12+SAMPTR),L
	LD (IY-12+SAMPTR+1),H
	JR PD_LOOP

PD_VOL	RLCA
	RLCA
	RLCA
	RLCA
	LD (IY-12+VOLUME),A
	JR PD_LP2
	
PD_EOFF	LD (IY-12+ENV_EN),A
	LD (IY-12+PSINOR),A
	JR PD_LP2

PD_SORE	DEC A
	JR NZ,PD_ENV
	LD A,(BC)
	INC BC
	LD (IY-12+NNTSKP),A
	JR PD_LP2

PD_ENV	CALL SETENV
	JR PD_LP2

PD_ORN	CALL SETORN
	JR PD_LOOP

PD_ESAM	LD (IY-12+ENV_EN),A
	LD (IY-12+PSINOR),A
	CALL NZ,SETENV
	LD A,(BC)
	INC BC
	JR PD_SAM_

PTDECOD LD A,(IY-12+NOTE)
	LD (PRNOTE+1),A
	LD L,(IY-12+CRTNSL)
	LD H,(IY-12+CRTNSL+1)
	LD (PRSLIDE+1),HL

PD_LOOP	LD DE,$2010
PD_LP2	LD A,(BC)
	INC BC
	ADD A,E
	JR C,PD_ORSM
	ADD A,D
	JR Z,PD_FIN
	JR C,PD_SAM
	ADD A,E
	JR Z,PD_REL
	JR C,PD_VOL
	ADD A,E
	JR Z,PD_EOFF
	JR C,PD_SORE
	ADD A,96
	JR C,PD_NOTE
	ADD A,E
	JR C,PD_ORN
	ADD A,D
	JR C,PD_NOIS
	ADD A,E
	JR C,PD_ESAM
	ADD A,A
	LD E,A
	LD HL,SPCCOMS+$FF20-$2000
	ADD HL,DE
	LD E,(HL)
	INC HL
	LD D,(HL)
	PUSH DE
	JR PD_LOOP

PD_NOIS	LD (NS_BASE),A
	JR PD_LP2

PD_REL	RES 0,(IY-12+FLAGS)
	JR PD_RES
	
PD_NOTE	LD (IY-12+NOTE),A
	SET 0,(IY-12+FLAGS)
	XOR A

	;so the following code
	;basically loads 12 copies of a
	;into memory bytes pointed to by IY - 1
	;sp points to lsb of current top word
	
PD_RES
	ld	(PDSP_ + 2),IY		; save IY, the load IY is a 4 byte instruction !
	ld 	h,12				; counter
	
pd_store_again:
	dec	IY				; decrement IY before first store
	ld	(IY + 0),a		; store a				
	dec	h				; decrement counter
	jr	nz,pd_store_again	; loop 12 times
	ld 	h,a				;orignal code leave h & l = a
	ld	l,a	
	
;	LD (PDSP_+1),SP		
;	LD SP,IY			
;	LD H,A
;	LD L,A
;	PUSH HL
;	PUSH HL
;	PUSH HL
;	PUSH HL
;	PUSH HL
;	PUSH HL

PDSP_	
	
;	LD SP,$3131			;self modding code	
	ld IY,$3131			;restore IY
	
PD_FIN	LD A,(IY-12+NNTSKP)
	LD (IY-12+NTSKCN),A
	RET

C_PORTM RES 2,(IY-12+FLAGS)
	LD A,(BC)
	INC BC
;SKIP PRECALCULATED TONE DELTA (BECAUSE
;CANNOT BE RIGHT AFTER PT3 COMPILATION)
	INC BC
	INC BC
	LD (IY-12+TNSLDL),A
	LD (IY-12+TSLCNT),A
	LD DE,NT_
	LD A,(IY-12+NOTE)
	LD (IY-12+SLTONT),A
	ADD A,A
	LD L,A
	LD H,0
	ADD HL,DE
	LD A,(HL)
	INC HL
	LD H,(HL)
	LD L,A
	PUSH HL
PRNOTE	LD A,$3E
	LD (IY-12+NOTE),A
	ADD A,A
	LD L,A
	LD H,0
	ADD HL,DE
	LD E,(HL)
	INC HL
	LD D,(HL)
	POP HL
	SBC HL,DE
	LD (IY-12+TNDELT),L
	LD (IY-12+TNDELT+1),H
	LD E,(IY-12+CRTNSL)
	LD D,(IY-12+CRTNSL+1)
VERSION EQU $+1
	LD A,$3E
	CP 6
	JR C,OLDPRTM ;OLD 3XXX FOR PT V3.5-
PRSLIDE	LD DE,$1111
	LD (IY-12+CRTNSL),E
	LD (IY-12+CRTNSL+1),D
OLDPRTM	LD A,(BC) ;SIGNED TONE STEP
	INC BC
;	EX AF,AF'
;replace with macro
	exaf
	
	LD A,(BC)
	INC BC
	AND A
	JR Z,NOSIG
	EX DE,HL
NOSIG	SBC HL,DE
	JP P,SET_STP

;complement this A register
;and negate the A' register
	CPL
;EXX\ PUSH AF\ EX (SP),HL\ POP AF\ EXX\ neg\ EXX\ PUSH AF\ EX (SP),HL\ POP AF\ EXX


;shorter than the macro implementation.
	
	exx
	push	af
	ex (sp),hl	
	pop af			;swapped af's
	neg
	push af
	ex (sp),hl		;swapped back
	pop	af
	exx

; ;	EX AF,AF'
; ;replace with macro
; 	exaf
; 	
; 	NEG
; ;	EX AF,AF'
; ;replace with macro
; 	exaf
; 	
SET_STP	LD (IY-12+TSLSTP+1),A
;	EX AF,AF'
;replace with macro
 	exaf
	
	LD (IY-12+TSLSTP),A
	LD (IY-12+CONOFF),0
	RET

C_GLISS	SET 2,(IY-12+FLAGS)
	LD A,(BC)
	INC BC
	LD (IY-12+TNSLDL),A
	AND A
	JR NZ,GL36
	LD A,(VERSION) ;ALCO PT3.7+
	CP 7
	SBC A,A
	INC A
GL36	LD (IY-12+TSLCNT),A
	LD A,(BC)
	INC BC
;	EX AF,AF'
;replace with macro
	exaf
	
	LD A,(BC)
	INC BC
	JR SET_STP

C_SMPOS	LD A,(BC)
	INC BC
	LD (IY-12+PSINSM),A
	RET

C_ORPOS	LD A,(BC)
	INC BC
	LD (IY-12+PSINOR),A
	RET

C_VIBRT	LD A,(BC)
	INC BC
	LD (IY-12+ONOFFD),A
	LD (IY-12+CONOFF),A
	LD A,(BC)
	INC BC
	LD (IY-12+OFFOND),A
	XOR A
	LD (IY-12+TSLCNT),A
	LD (IY-12+CRTNSL),A
	LD (IY-12+CRTNSL+1),A
	RET

C_ENGLS	LD A,(BC)
	INC BC
	LD (ENV_DEL),A
	LD (CUREDEL),A
	LD A,(BC)
	INC BC
	LD L,A
	LD A,(BC)
	INC BC
	LD H,A
	LD (ESLDADD),HL
	RET

C_DELAY	LD A,(BC)
	INC BC
	LD (DELAY),A
	RET
	
SETENV	LD (IY-12+ENV_EN),E
	LD (AYREGS+ENVTP),A
	LD A,(BC)
	INC BC
	LD H,A
	LD A,(BC)
	INC BC
	LD L,A
	LD (ENVBASE),HL
	XOR A
	LD (IY-12+PSINOR),A
	LD (CUREDEL),A
	LD H,A
	LD L,A
	LD (CURESLD),HL
C_NOP	RET

SETORN	ADD A,A
	LD E,A
	LD D,0
	LD (IY-12+PSINOR),D
ORNPTRS	EQU $+1
	LD HL,$2121
	ADD HL,DE
	LD E,(HL)
	INC HL
	LD D,(HL)
MDADDR2	EQU $+1
	LD HL,$2121
	ADD HL,DE
	LD (IY-12+ORNPTR),L
	LD (IY-12+ORNPTR+1),H
	RET

;ALL 16 ADDRESSES TO PROTECT FROM BROKEN PT3 MODULES
SPCCOMS DW C_NOP
	DW C_GLISS
	DW C_PORTM
	DW C_SMPOS
	DW C_ORPOS
	DW C_VIBRT
	DW C_NOP
	DW C_NOP
	DW C_ENGLS
	DW C_DELAY
	DW C_NOP
	DW C_NOP
	DW C_NOP
	DW C_NOP
	DW C_NOP
	DW C_NOP

CHREGS	XOR A
	LD (AMPL),A
	BIT 0,(IY+FLAGS)
	PUSH HL
	JP Z,CH_EXIT

;==============================================================
;	LD (CSP_+1),SP			;save stack pointer
	

;========================

	LD L,(IY+ORNPTR)		;
	LD H,(IY+ORNPTR+1)		; hl now holds new value for SP

;==============================================================
;	LD SP,HL				;new value for sp
;	POP DE				; so de would be loaded from, e = (hl), d = (hl+1)

	ld	e,(hl)			;sp = low byte
	inc	hl				;sp = sp + 1
	ld	d,(hl)			;sp(+1) = high byte
	inc	hl				;pop would make sp = sp + 2

;
;but do need to store it
;for use later
	ld	b,h
	ld	c,l				;old sp value is now in bc
;=============================


	
	LD H,A				;and now hl is gone !
	LD A,(IY+PSINOR)
	LD L,A
						;but we need old hl to add to this hl..
;==================================================================
						
;	ADD HL,SP				;add sp to new hl, hl holds new value 
						;does not affect value of sp
	add	hl,bc			;bc was old value of HL (sp)
						;so hl = hl + old hl
						;bc still holds what SP would be at this point
;=======================

	INC A
	CP D
	JR C,CH_ORPS
	LD A,E
CH_ORPS	LD (IY+PSINOR),A
	LD A,(IY+NOTE)
	
;=================================================================
; no change needed
	ADD A,(HL)			;byte pointed to by hl
						;remember bc is still our old sp
;==============================

	JP P,CH_NTP
	XOR A
CH_NTP	CP 96
	JR C,CH_NOK
	LD A,95
CH_NOK	ADD A,A
;	EX AF,AF'
;replace with macro
	exaf
	
;anyway round we end up here

	LD L,(IY+SAMPTR)
	LD H,(IY+SAMPTR+1)
	
;==================================================================

;	LD SP,HL				;new value for sp
;	POP DE				; so de would be loaded from, e = (hl), d = (hl+1)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl				;pop would make sp = sp + 2
;
;but do need to store it
;for use later
	ld	b,h
	ld	c,l				;old value is now in bc
;=================================


	LD H,0
	LD A,(IY+PSINSM)
	
;================================================================
;	LD B,A				;b currently storing H
	ld	(b_stor),a
;=============================

	ADD A,A
	ADD A,A
	LD L,A

;================================================================
; old sp is in bc, hl is a new offset

;	ADD HL,SP				; add sp to hl
;	LD SP,HL				; new val for sp

	add	hl,bc			;now sp in hl, bc = invalid
;==============================

;=================================================================
;	LD A,B
b_stor EQU $+1
	ld	a,$01			;self modified operand
;==============================

	
	INC A
	CP D
	JR C,CH_SMPS
	LD A,E
CH_SMPS	LD (IY+PSINSM),A

;==================================================================
;tricky !
;hl is our pointer !

;	POP BC
;	POP HL
	
;pop bc
	ld	c,(hl)		;this is ok our old bc is invalid anyway
	inc	hl
	ld	b,(hl)
	inc	hl
	
;pop hl, de reloaded after this so ok hl is our pointer, so pop de instead
	ld	e,(hl)
	inc	hl
	ld	h,(hl)
;	inc	hl	
;nowhere to save hl....

;hl = de, lost sp !
;	ld	h,d
	ld	l,e	
;sp lost....
;but looks ok next section does not use it
;then it is reloaded with NT_
;=================================



	LD E,(IY+TNACC)
	LD D,(IY+TNACC+1)
	ADD HL,DE
	BIT 6,B
	JR Z,CH_NOAC
	LD (IY+TNACC),L
	LD (IY+TNACC+1),H
CH_NOAC EX DE,HL
;	EX AF,AF'
;replace with macro
	exaf
	
;	LD L,A
	LD H,0

	ld	hl,NT_
	add	a,l
	ld	l,a
	ld	a,h
	adc	a,$00		;add carry to H
	ld	h,a
	
	;hl now holds the sp value 
;=================================================
; at this point bc, hl, de all hold valid values.
; hl can be dispensed with after the ld sp,hl
;
; a is not used either, wonder if i can make it shorter/quicker ?
; since h=0 i can add a to c and any carry to b


;	LD SP,NT_				;new value for sp
;
; bc already holds a value 
;	push bc				;save bc
;	ld	bc,NT_			;use bc instead of sp
	
;	ADD HL,SP				; add offset
;	add	hl,bc			; add the offset, our sp is now in hl

;	LD SP,HL				; result into sp
;	POP HL

	
; now we 'pop hl'	
	ld	a,(hl)			;low byte into a
	inc	hl
	ld	h,(hl)			;high byte into h
;	inc 	hl				;and the point of that would be ?
;	bc is transfered to hl so no need to inc it again.
	
;	and transfer to hl
;	ld	h,b
	ld	l,a

;	pop	bc				;and then restore bc
;================================
	
	ADD HL,DE				;add de
	LD E,(IY+CRTNSL)		;get new value
	LD D,(IY+CRTNSL+1)		
	ADD HL,DE				;and add that aswell

;======================================================	
;CSP_	LD SP,$3131			;restore stack pointer	
;=============================

	EX (SP),HL
	XOR A
	OR (IY+TSLCNT)
	JR Z,CH_AMP
	DEC (IY+TSLCNT)
	JR NZ,CH_AMP
	LD A,(IY+TNSLDL)
	LD (IY+TSLCNT),A
	LD L,(IY+TSLSTP)
	LD H,(IY+TSLSTP+1)
	LD A,H
	ADD HL,DE
	LD (IY+CRTNSL),L
	LD (IY+CRTNSL+1),H
	BIT 2,(IY+FLAGS)
	JR NZ,CH_AMP
	LD E,(IY+TNDELT)
	LD D,(IY+TNDELT+1)
	AND A
	JR Z,CH_STPP
	EX DE,HL
CH_STPP SBC HL,DE
	JP M,CH_AMP
	LD A,(IY+SLTONT)
	LD (IY+NOTE),A
	XOR A
	LD (IY+TSLCNT),A
	LD (IY+CRTNSL),A
	LD (IY+CRTNSL+1),A
CH_AMP	LD A,(IY+CRAMSL)
	BIT 7,C
	JR Z,CH_NOAM
	BIT 6,C
	JR Z,CH_AMIN
	CP 15
	JR Z,CH_NOAM
	INC A
	JR CH_SVAM
CH_AMIN	CP -15
	JR Z,CH_NOAM
	DEC A
CH_SVAM	LD (IY+CRAMSL),A
CH_NOAM	LD L,A
	LD A,B
	AND 15
	ADD A,L
	JP P,CH_APOS
	XOR A
CH_APOS	CP 16
	JR C,CH_VOL
	LD A,15
CH_VOL	OR (IY+VOLUME)
	LD L,A
	LD H,0
	LD DE,VT_
	ADD HL,DE
	LD A,(HL)
CH_ENV	BIT 0,C
	JR NZ,CH_NOEN
	OR (IY+ENV_EN)
CH_NOEN	LD (AMPL),A
	BIT 7,B
	LD A,C
	JR Z,NO_ENSL
	RLA
	RLA
	SRA A
	SRA A
	SRA A
	ADD A,(IY+CRENSL) ;SEE COMMENT BELOW
	BIT 5,B
	JR Z,NO_ENAC
	LD (IY+CRENSL),A
NO_ENAC	LD HL,ADDTOEN
	ADD A,(HL) ;BUG IN PT3 - NEED WORD HERE.
		   ;FIX IT IN NEXT VERSION?
	LD (HL),A
	JR CH_MIX
NO_ENSL RRA
	ADD A,(IY+CRNSSL)
	LD (ADDTONS),A
	BIT 5,B
	JR Z,CH_MIX
	LD (IY+CRNSSL),A
CH_MIX	LD A,B
	RRA
	AND $48
CH_EXIT	LD HL,AYREGS+MIXER
	OR (HL)
	RRCA
	LD (HL),A
	POP HL
	XOR A
	OR (IY+CONOFF)
	RET Z
	DEC (IY+CONOFF)
	RET NZ
	XOR (IY+FLAGS)
	LD (IY+FLAGS),A
	RRA
	LD A,(IY+ONOFFD)
	JR C,CH_ONDL
	LD A,(IY+OFFOND)
CH_ONDL	LD (IY+CONOFF),A
	RET

PLAY
	EXX
	PUSH	HL
	EXX
	CALL PLAY_2_MOD7
	EXX
	POP	HL
	EXX
	RET
	
PLAY_2_MOD7:

	XOR A				;this is plat routine
						;zero accumulator for a start
	LD (ADDTOEN),A			;modifies a bit of code further on
						;this value is added to the envelope
						;value
						
	LD (AYREGS+MIXER),A		;get the mixer current mixer value in a
	DEC A				;and decrement it. 
	
	LD (AYREGS+ENVTP),A		;and save it in envtp (envelope time period)
	LD HL,DELYCNT			;hl points to delay counter
	DEC (HL)				;decrement counter
	
;a modification later on has made relative brach too far
;	JR NZ,PL2
	jp nz,PL2				;if not zero jump
						;continue playing whatever was playing
						;it doesn't mean do nothing, there may be
						;ornaments or other effects that 
						;want updating
						
;OK delay is up time to move on to next position in patternm i guess						

	LD HL,CHANA+NTSKCN		;not sure what exactly this is yet!
	DEC (HL)				;but we are decrementing it anyway 
	JR NZ,PL1B			;if not zero jump
	
;so the whatever it is has reached zero

ADINPTA	EQU $+1
	LD BC,$0101			;the operand here is modified elsewhere
	LD A,(BC)				;get value
	AND A				;is zero ?
	JR NZ,PL1A			;jump if not zero
	
	LD D,A				;d=0
	LD (NS_BASE),A			;zero ?
	LD HL,(CRPSPTR)		;get current position pointer
	INC HL				;increment it
	LD A,(HL)				;get whatever is pointed by it
	INC A				;increment that too
	JR NZ,PLNLP			;rolled round to zero ?
						;jump if not
	
	CALL CHECKLP				;player has reached loop point
							;set the loop marker
							;and test the loop / no loop bit
							;returns here if looping is allowed
							;
							;else the return address is dropped
							;and the player muted
							
	
LPOSPTR	EQU $+1
	LD HL,$2121				;this argument is self modified at the beggining
							;of the initalise routine
							;and is the pointer to the position  
							;player loops back to
							
	LD A,(HL)					;get position number
	INC A					;+1
PLNLP	LD (CRPSPTR),HL		;save in current position

	DEC A					;-1
	ADD A,A					;and double result
	LD E,A					;low byte into e
	RL D						;carry into d
							;if we got here d will have been zero before
							; the RL instruction
PATSPTR	EQU $+1
	LD HL,$2121				;this argument is self modified near the
							;beginning of the initialise
							;it is the pointer to the positions data
	ADD HL,DE					;add the offset held in DE
	

	;following was original code
	LD DE,(MODADDR)			;load de with the original module address

	
	
;=====================================================	
;	LD (PSP_+1),SP				;save stack pointer
;	LD SP,HL					;new value for sp
;
; original code ends here

;ignore till next ******************

;think i am going to tackle this in a different way to the previous section
;i will retrieve the 3 words and push them onto the machine stack
;
; then continue with exsisting code
;
; de and hl currently hold valid values
; hl is address from where i want to 'pop' words
; it can be destroyed since as when code continues first real pop
; is pop hl
; i can use the a register too, as after this section PTDECODE is called
; and first instruction loads a

; bugger they will be on the stack back-to-front !
; need 
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl			;point to high byte of last item first !
	

	ld	a,3
pat_pointer_loop:
	ld b,(hl)
	dec hl
	ld c,(hl)
	dec hl
	push bc
	dec a
	jr nz,pat_pointer_loop
;*******************************

;original code again.

	POP HL
	ADD HL,DE
	LD B,H
	LD C,L
	POP HL
	ADD HL,DE
	LD (ADINPTB),HL
	POP HL
	ADD HL,DE
	LD (ADINPTC),HL
;========================================================
;PSP_	LD SP,$3131				;restore stack pointer
;====================

PL1A	LD IY,CHANA+12
	CALL PTDECOD
	LD (ADINPTA),BC

PL1B	LD HL,CHANB+NTSKCN
	DEC (HL)
	JR NZ,PL1C
	LD IY,CHANB+12
ADINPTB	EQU $+1
	LD BC,$0101
	CALL PTDECOD
	LD (ADINPTB),BC

PL1C	LD HL,CHANC+NTSKCN
	DEC (HL)
	JR NZ,PL1D
	LD IY,CHANC+12
ADINPTC	EQU $+1
	LD BC,$0101
	CALL PTDECOD
	LD (ADINPTC),BC

DELAY	EQU $+1
PL1D	LD A,$3E				;self modified operand
	LD (DELYCNT),A			;reset the delay counter

PL2	LD IY,CHANA			;continue with current position
	LD HL,(AYREGS+TONA)		;
	CALL CHREGS
	LD (AYREGS+TONA),HL
	LD A,(AMPL)
	LD (AYREGS+AMPLA),A
	LD IY,CHANB
	LD HL,(AYREGS+TONB)
	CALL CHREGS
	LD (AYREGS+TONB),HL
	LD A,(AMPL)
	LD (AYREGS+AMPLB),A
	LD IY,CHANC
	LD HL,(AYREGS+TONC)
	CALL CHREGS
;	LD A,(AMPL) ;AMPL = AYREGS+AMPLC	;oh i get it
;	LD (AYREGS+AMPLC),A				
	LD (AYREGS+TONC),HL

	LD HL,(NS_BASE_ADDTONS)
	LD A,H
	ADD A,L
	LD (AYREGS+NOISE),A

ADDTOEN EQU $+1
	LD A,$3E
	LD E,A
	ADD A,A
	SBC A,A
	LD D,A
	LD HL,(ENVBASE)
	ADD HL,DE
	LD DE,(CURESLD)
	ADD HL,DE
	LD (AYREGS+ENV),HL

	XOR A
	LD HL,CUREDEL
	OR (HL)
	JR Z,ROUT_A0
	DEC (HL)
	JR NZ,ROUT
ENV_DEL	EQU $+1
	LD A,$3E
	LD (HL),A
ESLDADD	EQU $+1
	LD HL,$2121
	ADD HL,DE
	LD (CURESLD),HL

ROUT	
	XOR A				;zero acumulator, start at register 0
ROUT_A0					;jump here with a already loaded for partial
						;register updates
	ld	de,$df1f			;altered by andy rea to use ZON-x ports
	ld	bc,$ffdf
	
	LD HL,AYREGS			;pointer to data to send out
						;to the ay chip
						
LOUT	
	OUT (C),A			;$ffdf, select the register
	ld	c,e
	OUTI 			;$ff1f, write data to that register (increments hl)
	ld	c,d			;switch back to register select port
	INC A			;next register
	CP 13			;got to register 13 yet ?
	JR NZ,LOUT		;no loop back
	OUT (C),A			;$ffdf , selecy register 13 (envelope control)
	LD A,(HL)			;get the value for it
	AND A			;check bit 7 ? minus
	RET M			;yes finished here
	ld	c,e			;else data port
	OUT (C),A			;$ff1f, and write data
	RET				;then finished

NT_DATA	DB (T_NEW_0-T1_)*2
	DB TCNEW_0-T_
	DB (T_OLD_0-T1_)*2+1
	DB TCOLD_0-T_
	DB (T_NEW_1-T1_)*2+1
	DB TCNEW_1-T_
	DB (T_OLD_1-T1_)*2+1
	DB TCOLD_1-T_
	DB (T_NEW_2-T1_)*2
	DB TCNEW_2-T_
	DB (T_OLD_2-T1_)*2
	DB TCOLD_2-T_
	DB (T_NEW_3-T1_)*2
	DB TCNEW_3-T_
	DB (T_OLD_3-T1_)*2
	DB TCOLD_3-T_

T_

TCOLD_0	DB $00+1,$04+1,$08+1,$0A+1,$0C+1,$0E+1,$12+1,$14+1
	DB $18+1,$24+1,$3C+1,0
TCOLD_1	DB $5C+1,0
TCOLD_2	DB $30+1,$36+1,$4C+1,$52+1,$5E+1,$70+1,$82,$8C,$9C
	DB $9E,$A0,$A6,$A8,$AA,$AC,$AE,$AE,0
TCNEW_3	DB $56+1
TCOLD_3	DB $1E+1,$22+1,$24+1,$28+1,$2C+1,$2E+1,$32+1,$BE+1,0
TCNEW_0	DB $1C+1,$20+1,$22+1,$26+1,$2A+1,$2C+1,$30+1,$54+1
	DB $BC+1,$BE+1,0
TCNEW_1 EQU TCOLD_1
TCNEW_2	DB $1A+1,$20+1,$24+1,$28+1,$2A+1,$3A+1,$4C+1,$5E+1
	DB $BA+1,$BC+1,$BE+1,0

EMPTYSAMORN EQU $-1
	DB 1,0,$90 ;DELETE $90 IF YOU DON'T NEED DEFAULT SAMPLE

;FIRST 12 VALUES OF TONE TABLES (PACKED)

T_PACK	
	

	DB $06EC*2/256,$06EC*2
	DB $0755-$06EC
	DB $07C5-$0755
	DB $083B-$07C5
	DB $08B8-$083B
	DB $093D-$08B8
	DB $09CA-$093D
	DB $0A5F-$09CA
	DB $0AFC-$0A5F
	DB $0BA4-$0AFC
	DB $0C55-$0BA4
	DB $0D10-$0C55
	DB $066D*2/256,$066D*2
	DB $06CF-$066D
	DB $0737-$06CF
	DB $07A4-$0737
	DB $0819-$07A4
	DB $0894-$0819
	DB $0917-$0894
	DB $09A1-$0917
	DB $0A33-$09A1
	DB $0ACF-$0A33
	DB $0B73-$0ACF
	DB $0C22-$0B73
	DB $0CDA-$0C22
	DB $0704*2/256,$0704*2
	DB $076E-$0704
	DB $07E0-$076E
	DB $0858-$07E0
	DB $08D6-$0858
	DB $095C-$08D6
	DB $09EC-$095C
	DB $0A82-$09EC
	DB $0B22-$0A82
	DB $0BCC-$0B22
	DB $0C80-$0BCC
	DB $0D3E-$0C80
	DB $07E0*2/256,$07E0*2
	DB $0858-$07E0
	DB $08E0-$0858
	DB $0960-$08E0
	DB $09F0-$0960
	DB $0A88-$09F0
	DB $0B28-$0A88
	DB $0BD8-$0B28
	DB $0C80-$0BD8
	DB $0D60-$0C80
	DB $0E10-$0D60
	DB $0EF8-$0E10
	
;VARS FROM HERE CAN BE STRIPPED
;YOU CAN MOVE VARS TO ANY OTHER ADDRESS
	
	ORG 48611
VARS

CHANA	DS CHP
CHANB	DS CHP
CHANC	DS CHP

;GLOBALVARS
; DELYCNT	DB 0
; CURESLD	DW 0
; CUREDEL	DB 0
; NS_BASE_ADDTONS
; NS_BASE	DB 0
; ADDTONS	DB 0

DELYCNT	DS 1
CURESLD	DS 2
CUREDEL	DS 1
NS_BASE_ADDTONS
NS_BASE	DS 1
ADDTONS	DS 1

AYREGS

VT_	DS 256 ;CREATEDVOLUMETABLEADDRESS

ENVBASE	EQU VT_+14

T1_	EQU VT_+16 ;TONE TABLES DATA DEPACKED HERE

T_OLD_1	EQU T1_
T_OLD_2	EQU T_OLD_1+24
T_OLD_3	EQU T_OLD_2+24
T_OLD_0	EQU T_OLD_3+2
T_NEW_0	EQU T_OLD_0
T_NEW_1	EQU T_OLD_1
T_NEW_2	EQU T_NEW_0+24
T_NEW_3	EQU T_OLD_3

NT_	DS 192 ;CREATEDNOTETABLEADDRESS

;LOCAL VAR
AMPL	EQU AYREGS+AMPLC

VAR0END	EQU VT_+16 ;INIT ZEROES FROM VARS TO VAR0END-1

VARSEND EQU $
			
;NT_last_byte DB $00		;this is here to make the compiler
					;generate a file as long as
					;the code + VARS

;a_stor: DW $00		;byte to temp store acumulator, instead of ex af,af'
MDLADDR EQU $

;RELEASE 0 STEPS:
;11.SEP.2004 - NOTE TABLES CREATOR
;12.SEP.2004 - VOLUME TABLES CREATOR; INIT SUBROUTINE
;13.SEP.2004 - PLAY COUNTERS, POSITION COUNTERS
;14.SEP.2004 - PATTERNS DECODER SUBROUTINE
;15.SEP.2004 - RESTING (NO CODE)
;16.SEP.2004 - CHREGS SUBROUTINE; GLOBAL DEBUGGING; 1ST STABLE
;VERSION WAS BORN
;17.SEP.2004 - DEBUGGING AND OPTIMIZATION. FIRST RELEASE!
;RELEASE 1 STEPS:
;20.SEP.2004 - LOCAL VARS MOVED TO CODE (SELFMODIFIED CODE
;SMALLER AND FASTER)
;22.SEP.2004 - ADDED MUTE SOUND ENTRY AT START+8; POSITION
;POINTER MOVED TO START+11; ADDED SETUP AND STATUS BYTE AT
;START+10 NOLOOP MODE AND LOOP PASSED FLAGS ADDED
;RELEASE 2 STEPS:
;28.SEP.2004 - OPTIMIZATION: CODE AROUND CHREGS'S VOLUME AND
;VIBRATO FASTER NOW; ZEROING PD_RES THROUGH STACK; TON AND AMPL
;MOVED FROM CHANNEL VARS TO GLOBAL ONES; FIRST POSITION SELECTOR
;REMOVED FROM INIT; OPTIMIZATION FOR PACKERS(IVAN ROSHIN METHOD)
;RELEASE 3 STEPS:
;2.OCT.2004 - OPTIMIZATION IN INIT AND PD_LOOP (THANKS TO IVAN
;ROSHIN)
;4.OCT.2004 - LOAD DELAY FROM (HL) IN INIT (2 BYTES SHORTER)
;5.OCT.2004 - OPTIMIZATION IN PD_LOOP (->PD_LP2)
;7.OCT.2004 - SWAPING SOME COMMANDS FOR BETTER PACKING
;RELEASE 4 STEPS:
;9.OCT.2004 - OPTIMIZATION AROUND LD HL,SPCCOMS (THANKS TO IVAN
;ROSHIN); IN PTDECOD SWAPPED BC AND DE TO OPTIMIZE C_PORTM;
;REMOVED SAM AND ORN LEN AND LOOP CHANNEL VARS; CHREGS TOTALLY
;OPTIMIZED
;RELEASE 5 STEPS:
;11.OCT.2004 - PD_ORSM AND C_PORTM OPTIMIZED; IVAN ROSHIN'S
;VOLUME TABLES CREATOR ALGORITHM (51 BYTES SHORTER THAN MINE)
;12.OCT.2004 - IVAN ROSHIN'S NOTE TABLES CREATOR ALGORITHM (74
;BYTES SHORTER THAN MINE)
;RELEASE 6 STEPS:
;14.OCT.2004 - LOOP AND NEXT POSITION CALCULATIONS MOVED TO INIT
;15.OCT.2004 - ADINPT MOVED TO CODE
;19.OCT.2004 - ENV_DEL MOVED TO CODE
;20.OCT.2004 - VERSION PUSH AND POP (1 BYTE SHORTER, THANKS TO
;IVAN ROSHIN)
;22.OCT.2004 - ENV_EN MOVED FROM FLAGS' BIT TO BYTE (SHORTER AND
;FASTER CODE)
;25.OCT.2004 - SETENV OPTIMIZED
;29.OCT.2004 - OPTIMIZED AROUND ADDTOEN (SBC A,A, THANKS TO IVAN
;ROSHIN)
;3.NOV.2004 - NOTE TABLES DATA WAS COMPRESSED; WITH DEPACKER IT
;IS 9 BYTES SHORTER THAN UNCOMPRESSED (THANKS TO IVAN ROSHIN)
;4.NOV.2004 - DEFAULT SAMPLE AND ORNAMENT BOTH ARE FIXED NOW
;AND PLACED INTO CODE BLOCK (6 BYTES SHORTER)
;7.NOV.2004 - LD A,(NS_BASE):LD L,A CHANGED TO LD HL,(NS_BASE)
;(THANKS TO DIMA BYSTROV)
;9.NOV.2004 - NS_BASE AND ADDTONS ARE MERGED TO NS_BASE_ADDTONS;
;LD A,255 CHANGED TO DEC A (AT START OF PLAY); ADDED ROUT_A0
;12.NOV.2004 - NTSKCN&VOLUME ARE MERGED (8 BYTES SMALLER INIT);
;LD BC,T1_ CHANGED TO PUSH DE...POP BC IN NOTE TABLE CREATOR
;19.DEC.2004 - NT_DATA REORGANIZED (6 BYTES SHORTER, THANKS TO
;IVAN ROSHIN); C_PORTM AND C_GLISS ARE MERGED VIA SET_STP (48
;TACTS SLOWER, BUT 8 BYTES SMALLER, THANKS TO IVAN ROSHIN)
;RELEASE 7 STEPS:
;29.APR.2007 - SJASM ADAPTATION; NEW 1.XX AND 2.XX
;INTERPRETATION FOR PT 3.7+.

;TESTS IN IMMATION TESTER V1.0 BY ANDY MAN/POS (THANKS TO
;HIMIK'S ZXZ FOR HELP):
;MODULE NAME/AUTHOR	MIN TACTS	MAX TACTS	AVERAGE
;SPLEEN/NIK-O		1720		9256		5500
;CHUTA/MIGUEL		1720		9496		5500
;ZHARA/MACROS		4536		8744		5500

;SIZE:
;CODE BLOCK $651 BYTES
;VARIABLES $21D BYTES (CAN BE STRIPPED)
;SIZE IN RAM $651+$21D=$86E (2158) BYTES

;NOTES:
;PRO TRACKER 3.4R CAN NOT BE DETECTED BY HEADER, SO PT3.4R TONE
;TABLES REALLY USED ONLY FOR MODULES OF 3.3 AND OLDER VERSIONS.


	.end